CREATE SCHEMA Strassenzustandsdaten

-- Historie:
--
-- 15.10.1999 - 1.000 (1.000)
-- Erste Version des OKSTRA verabschiedet

CREATE TABLE ZEB_Objekt (
   ZEB_Objekt_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (ZEB_Objekt_ID) REFERENCES Strassennetz.Streckenobjekt_stat,
   Kurzbezeichnung_ZEB_Objekt
      VARCHAR(8),
   ZEB_Objekt
      VARCHAR(30),
   Objektnummer
      INTEGER,
   hat_Verkehrsrichtung
      CHAR(1) NOT NULL REFERENCES Verkehr.Verkehrsrichtung,
   hat_ZEB_Projekt
      INTEGER NOT NULL REFERENCES ZEB_Projekt,
   hat_Art_des_ZEB_Objektes
      INTEGER NOT NULL REFERENCES Art_des_ZEB_Objektes
)

CREATE TABLE ZEB_Obj__gilt_f_Querschnittstr (
   ZEB_Objekt
      INTEGER NOT NULL REFERENCES ZEB_Objekt,
   Querschnittstreifen
      INTEGER NOT NULL REFERENCES Bauliche_Strasseneigenschaften.Querschnittstreifen
)

CREATE TABLE ZEB_Obj__gilt_f_Fahrstreifen (
   ZEB_Objekt
      INTEGER NOT NULL REFERENCES ZEB_Objekt,
   Fahrstreifen_Nummer
      INTEGER NOT NULL REFERENCES Verkehr.Fahrstreifen_Nummer
)

CREATE TABLE ZEB_Obj__hat_ZEB_Parameterwert (
   ZEB_Objekt
      INTEGER NOT NULL REFERENCES ZEB_Objekt,
   ZEB_Parameterwert
      INTEGER NOT NULL REFERENCES ZEB_Parameterwert
)

CREATE TABLE ZEB_Projekt (
   ZEB_Projekt_ID
      INTEGER NOT NULL PRIMARY KEY,
   Kurzbezeichnung_ZEB_Kamp
      VARCHAR(8),
   ZEB_Projekt
      VARCHAR(20),
   Hauptmessverfahren
      VARCHAR(20),
   Zweck
      VARCHAR(100),
   Umfang
      VARCHAR(200),
   hat_ZEB_Parameterliste
      INTEGER NOT NULL REFERENCES ZEB_Parameterliste
)

CREATE TABLE ZEB_Projekt__hat_Zeitraum (
   ZEB_Projekt
      INTEGER NOT NULL REFERENCES ZEB_Projekt,
   Zeitraum
      INTEGER NOT NULL REFERENCES Allgemeine_Objekte.Zeitraum
)

CREATE TABLE ZEB_Projekt__hat_ZEB_Ereignis (
   ZEB_Projekt
      INTEGER NOT NULL REFERENCES ZEB_Projekt,
   ZEB_Ereignis
      INTEGER NOT NULL REFERENCES ZEB_Ereignis
)

CREATE TABLE ZEB_Projekt__hat_ZEB_Subjekt (
   ZEB_Projekt
      INTEGER NOT NULL REFERENCES ZEB_Projekt,
   ZEB_Subjekt
      INTEGER NOT NULL REFERENCES ZEB_Subjekt
)

CREATE TABLE ZEB_Parameterwert (
   ZEB_Parameterwert_ID
      INTEGER NOT NULL PRIMARY KEY,
   Art_ZEB_Parameterwert
      INTEGER NOT NULL REFERENCES Art_ZEB_Parameterwert,
   Kurzbezeichnung
      VARCHAR(8),
   Wert
      VARCHAR(8),
   Einheit
      VARCHAR(8),
   von_ZEB_Parameter
      INTEGER NOT NULL REFERENCES ZEB_Parameter,
   von_ZEB_Ereignis
      INTEGER NOT NULL REFERENCES ZEB_Ereignis,
   Text_ZEB_Parameter
      VARCHAR(80), -- Eintrag_in_Beschreibungstext
   Kurzbez_Mess_Beschreibgroesse
      VARCHAR(8) -- Eintrag_in_Beschreibungstext
)

CREATE TABLE Art_ZEB_Parameterwert (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(29) NOT NULL
)

INSERT INTO Art_ZEB_Parameterwert VALUES (1,'Wert_der_Zustandsgroesse')
INSERT INTO Art_ZEB_Parameterwert VALUES (2,'Wert_eines_Messwertes')
INSERT INTO Art_ZEB_Parameterwert VALUES (3,'Wert_des_Zustandswertes')
INSERT INTO Art_ZEB_Parameterwert VALUES (4,'Eintrag_in_Beschreibungstext')
INSERT INTO Art_ZEB_Parameterwert VALUES (5,'Wert_des_Zustandsteilwertes')
INSERT INTO Art_ZEB_Parameterwert VALUES (6,'Wert_des_Zustandsgesamtwertes')
INSERT INTO Art_ZEB_Parameterwert VALUES (7,'zugewiesene_Zustandsklasse')

CREATE TABLE Art_des_ZEB_Objektes (
   Art_des_ZEB_Objektes_ID
      INTEGER NOT NULL PRIMARY KEY,
   Kurzbezeichnung_Objektart
      VARCHAR(8),
   ZEB_Objektart
      VARCHAR(30)
)

CREATE TABLE Art_d_ZEB_Obj__hat_Zustmerkmal (
   Art_des_ZEB_Objektes
      INTEGER NOT NULL REFERENCES Art_des_ZEB_Objektes,
   Zustandsmerkmal
      INTEGER NOT NULL REFERENCES Zustandsmerkmal
)

CREATE TABLE ZEB_Parameter (
   ZEB_Parameter_ID
      INTEGER NOT NULL PRIMARY KEY,
   Kurzbezeichnung_Paramgroesse
      VARCHAR(8),
   Parametergroesse
      VARCHAR(30),
   Parameternummer
      INTEGER,
   von_Zustgroesse_o_Zustwert
      INTEGER NOT NULL REFERENCES Zustandsgroesse_o_Zustandswert
)

CREATE TABLE ZEB_Dokument (
   ZEB_Dokument_ID
      INTEGER NOT NULL PRIMARY KEY,
   Kurzbezeichnung_ZEB_Dokument
      VARCHAR(8),
   ZEB_Dokument
      VARCHAR(20),
   Datum_der_Erstellung
      CHAR(10), -- Datum
   CHECK ( Datum_der_Erstellung LIKE '__.__.____' ),
   Ersteller
      VARCHAR(30),
   Art_des_Dokumentes
      VARCHAR(20)
)

CREATE TABLE ZEB_Ereignis (
   ZEB_Ereignis_ID
      INTEGER NOT NULL PRIMARY KEY,
   Kurzbezeichnung_ZEB_Ereignis
      VARCHAR(8),
   ZEB_Ereignis
      VARCHAR(20),
   hat_ZEB_Dokument
      INTEGER REFERENCES ZEB_Dokument
)

CREATE TABLE ZEB_Ereignis__hat_Zeitraum (
   ZEB_Ereignis
      INTEGER NOT NULL REFERENCES ZEB_Ereignis,
   Zeitraum
      INTEGER NOT NULL REFERENCES Allgemeine_Objekte.Zeitraum
)

CREATE TABLE ZEB_Ereignis__hat_ZEB_Subjekt (
   ZEB_Ereignis
      INTEGER NOT NULL REFERENCES ZEB_Ereignis,
   ZEB_Subjekt
      INTEGER NOT NULL REFERENCES ZEB_Subjekt
)

CREATE TABLE ZEB_Subjekt (
   ZEB_Subjekt_ID
      INTEGER NOT NULL PRIMARY KEY,
   Art_ZEB_Subjekt
      INTEGER NOT NULL REFERENCES Art_ZEB_Subjekt,
   Kurzbezeichnung_Subjekt
      VARCHAR(8),
   Subjekt
      VARCHAR(20),
   Adresse_Subjekt
      VARCHAR(100)
)

CREATE TABLE Art_ZEB_Subjekt (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(15) NOT NULL
)

INSERT INTO Art_ZEB_Subjekt VALUES (1,'ZEB_Erfasser')
INSERT INTO Art_ZEB_Subjekt VALUES (2,'ZEB_Bewerter')
INSERT INTO Art_ZEB_Subjekt VALUES (3,'ZEB_Veranlasser')

CREATE TABLE ZEB_Parameterliste (
   ZEB_Parameterliste_ID
      INTEGER NOT NULL PRIMARY KEY,
   Kurzbezeichnung_ZEB_Paramliste
      VARCHAR(8),
   Bezeichnung_ZEB_Parameterliste
      VARCHAR(20)
)

CREATE TABLE ZEB_Paramliste__hat_ZEB_Param (
   ZEB_Parameterliste
      INTEGER NOT NULL REFERENCES ZEB_Parameterliste,
   ZEB_Parameter
      INTEGER NOT NULL REFERENCES ZEB_Parameter
)

CREATE TABLE ZEB_Methode (
   ZEB_Methode_ID
      INTEGER NOT NULL PRIMARY KEY,
   Art_ZEB_Methode
      INTEGER NOT NULL REFERENCES Art_ZEB_Methode,
   Nummer
      INTEGER,
   Kurzbezeichnung
      CHAR(8),
   Methode
      VARCHAR(30),
   Beschreibung
      VARCHAR(120),
   hat_ZEB_Parameter
      INTEGER NOT NULL REFERENCES ZEB_Parameter
)

CREATE TABLE Art_ZEB_Methode (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(30) NOT NULL
)

INSERT INTO Art_ZEB_Methode VALUES (1,'Zustandsmessverfahren')
INSERT INTO Art_ZEB_Methode VALUES (2,'ZEB_visuell_sensit_Wahrnehmung')
INSERT INTO Art_ZEB_Methode VALUES (3,'Aggregationsmethode')
INSERT INTO Art_ZEB_Methode VALUES (4,'Normierungsmethode')
INSERT INTO Art_ZEB_Methode VALUES (5,'Kombinationsmethode')
INSERT INTO Art_ZEB_Methode VALUES (6,'Klassifizierungsmethode')

CREATE TABLE Zustandserfassungsmethode (
   Zustandserfassungsmethode_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Zustandserfassungsmethode_ID) REFERENCES ZEB_Methode
)

CREATE TABLE Zustandsbewertungsmethode (
   Zustandsbewertungsmethode_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Zustandsbewertungsmethode_ID) REFERENCES ZEB_Methode
)

CREATE TABLE Zustandsgroesse_o_Zustandswert (
   Zustandsgroesse_o_Zustandswert_ID
      INTEGER NOT NULL PRIMARY KEY,
   Art_der_Groesse
      VARCHAR(4),
   ID_ZEB_Parameter
      INTEGER
)

CREATE TABLE Zustgr_o_Zustw__bestbar_d_Meth (
   Zustandsgroesse_o_Zustandswert
      INTEGER NOT NULL REFERENCES Zustandsgroesse_o_Zustandswert,
   ZEB_Methode
      INTEGER NOT NULL REFERENCES ZEB_Methode
)

CREATE TABLE Zustandsindikator (
   Zustandsindikator_ID
      INTEGER NOT NULL PRIMARY KEY
)

CREATE TABLE Zustindik__hat_Zustgr_o_Zustw (
   Zustandsindikator
      INTEGER NOT NULL REFERENCES Zustandsindikator,
   Zustandsgroesse_o_Zustandswert
      INTEGER NOT NULL REFERENCES Zustandsgroesse_o_Zustandswert
)

CREATE TABLE Zustandsmerkmal (
   Zustandsmerkmal_ID
      INTEGER NOT NULL PRIMARY KEY
)

CREATE TABLE Zustmerkmal__hat_Zustindikator (
   Zustandsmerkmal
      INTEGER NOT NULL REFERENCES Zustandsmerkmal,
   Zustandsindikator
      INTEGER NOT NULL REFERENCES Zustandsindikator
)

CREATE TABLE Zustandsmessverfahren (
   Zustandsmessverfahren_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Zustandsmessverfahren_ID) REFERENCES Zustandserfassungsmethode,
   hat_Messwert_o_Beschrgroesse
      INTEGER NOT NULL REFERENCES Messwert_oder_Beschrgroesse
)

CREATE TABLE ZEB_visuell_sensit_Wahrnehmung (
   ZEB_visuell_sensit_Wahrnehmung_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (ZEB_visuell_sensit_Wahrnehmung_ID) REFERENCES Zustandserfassungsmethode,
   hat_Messwert_o_Beschrgroesse
      INTEGER NOT NULL REFERENCES Messwert_oder_Beschrgroesse
)

CREATE TABLE Aggregationsmethode (
   Aggregationsmethode_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Aggregationsmethode_ID) REFERENCES Zustandserfassungsmethode,
   hat_Messwert_o_Beschrgroesse
      INTEGER NOT NULL REFERENCES Messwert_oder_Beschrgroesse,
   hat_Zustandsgroesse
      INTEGER NOT NULL REFERENCES Zustandsgroesse
)

CREATE TABLE Normierungsmethode (
   Normierungsmethode_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Normierungsmethode_ID) REFERENCES Zustandsbewertungsmethode,
   hat_Zustandsgroesse
      INTEGER NOT NULL REFERENCES Zustandsgroesse,
   hat_Zustandswert
      INTEGER NOT NULL REFERENCES Zustandswert
)

CREATE TABLE Kombinationsmethode (
   Kombinationsmethode_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Kombinationsmethode_ID) REFERENCES Zustandsbewertungsmethode,
   hat_Zustandswert
      INTEGER NOT NULL REFERENCES Zustandswert,
   hat_Zustandsteilwert
      INTEGER REFERENCES Zustandsteilwert,
   hat_Zustandsgesamtwert
      INTEGER REFERENCES Zustandsgesamtwert,
   CHECK ( ( ( hat_Zustandsteilwert IS NOT NULL ) OR ( hat_Zustandsgesamtwert IS NOT NULL ) ) AND ( ( hat_Zustandsteilwert IS NULL ) OR ( hat_Zustandsgesamtwert IS NULL ) ) )
)

CREATE TABLE Kombmethode__hat_Zustteilwerte (
   Kombinationsmethode
      INTEGER NOT NULL REFERENCES Kombinationsmethode,
   Zustandsteilwert
      INTEGER NOT NULL REFERENCES Zustandsteilwert
)

CREATE TABLE Klassifizierungsmethode (
   Klassifizierungsmethode_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Klassifizierungsmethode_ID) REFERENCES Zustandsbewertungsmethode,
   hat_Zustandsgesamtwert
      INTEGER NOT NULL REFERENCES Zustandsgesamtwert,
   hat_Zustandsklasse
      INTEGER NOT NULL REFERENCES Zustandsklasse
)

CREATE TABLE Messwert_oder_Beschrgroesse (
   Messwert_oder_Beschrgroesse_ID
      INTEGER NOT NULL PRIMARY KEY,
   Kurzbezeichnung_Messw_o_Beschr
      VARCHAR(8),
   Messwert_Beschreibung
      VARCHAR(30)
)

CREATE TABLE Zustandsgroesse (
   Zustandsgroesse_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Zustandsgroesse_ID) REFERENCES Zustandsgroesse_o_Zustandswert
)

CREATE TABLE Zustandswert (
   Zustandswert_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Zustandswert_ID) REFERENCES Zustandsgroesse_o_Zustandswert
)

CREATE TABLE Zustandsteilwert (
   Zustandsteilwert_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Zustandsteilwert_ID) REFERENCES Zustandsgroesse_o_Zustandswert
)

CREATE TABLE Zustandsgesamtwert (
   Zustandsgesamtwert_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Zustandsgesamtwert_ID) REFERENCES Zustandsgroesse_o_Zustandswert
)

CREATE TABLE Zustandsklasse (
   Zustandsklasse_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Zustandsklasse_ID) REFERENCES Zustandsgroesse_o_Zustandswert
)


