CREATE SCHEMA Projektressourcen

-- Historie:
--
-- 15.10.1999 - 1.000 (1.000)
-- Erste Version des OKSTRA verabschiedet

CREATE TABLE Projektressourcen (
   Projektressourcen_ID
      INTEGER NOT NULL PRIMARY KEY,
   Bauanfang_Bau_km
      REAL NOT NULL, -- Kilometer
   CHECK ( Bauanfang_Bau_km>=0 ),
   endet_bei_Bauende
      REAL NOT NULL, -- Kilometer
   CHECK ( endet_bei_Bauende>=0 ),
   Ausbaulaenge
      REAL NOT NULL, -- Kilometer
   CHECK ( Ausbaulaenge>=0 ),
   ist_Kostenberechnung_nach_AKS
      INTEGER REFERENCES Kostenberechnung_nach_AKS,
   ist_Ausschreibung_und_Vergabe
      INTEGER REFERENCES Ausschreibung_und_Vergabe,
   ist_Abrechnung
      INTEGER REFERENCES Abrechnung
)

CREATE TABLE Kostenberechnung_nach_AKS (
   Kostenberechnung_nach_AKS_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Kostenberechnung_nach_AKS_ID) REFERENCES Dokumentenverweis
)

CREATE TABLE Ausschreibung_und_Vergabe (
   Ausschreibung_und_Vergabe_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Ausschreibung_und_Vergabe_ID) REFERENCES Dokumentenverweis
)

CREATE TABLE Abrechnung (
   Abrechnung_ID
      INTEGER NOT NULL PRIMARY KEY,
   FOREIGN KEY (Abrechnung_ID) REFERENCES Dokumentenverweis
)

CREATE TABLE Dokumentenverweis (
   Dokumentenverweis_ID
      INTEGER NOT NULL PRIMARY KEY
)


